# Enum Class VulkanQueryPipelineStatisticFlag

java.lang.Object
java.lang.Enum<VulkanQueryPipelineStatisticFlag>
com.io7m.jcoronado.api.VulkanQueryPipelineStatisticFlag

All Implemented Interfaces:
  `VulkanEnumBitmaskType`, `Serializable`, `Comparable<VulkanQueryPipelineStatisticFlag>`, `Constable`

public enum VulkanQueryPipelineStatisticFlag extends Enum<VulkanQueryPipelineStatisticFlag> implements VulkanEnumBitmaskType
Bitmask specifying queried pipeline statistics.

See Also:
  - "VkQueryPipelineStatisticFlagBits"

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VK_QUERY_PIPELINE_STATISTIC_CLIPPING_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of primitives processed by the Primitive Clipping stage of the pipeline.
  `VK_QUERY_PIPELINE_STATISTIC_CLIPPING_PRIMITIVES_BIT`
  Specifies that queries managed by the pool will count the number of primitives output by the Primitive Clipping stage of the pipeline.
  `VK_QUERY_PIPELINE_STATISTIC_COMPUTE_SHADER_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of compute shader invocations.
  `VK_QUERY_PIPELINE_STATISTIC_FRAGMENT_SHADER_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of fragment shader invocations.
  `VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of geometry shader invocations.
  `VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_PRIMITIVES_BIT`
  Specifies that queries managed by the pool will count the number of primitives generated by geometry shader invocations.
  `VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_PRIMITIVES_BIT`
  Specifies that queries managed by the pool will count the number of primitives processed by the input assembly stage.
  `VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_VERTICES_BIT`
  Specifies that queries managed by the pool will count the number of vertices processed by the input assembly stage.
  `VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_CONTROL_SHADER_PATCHES_BIT`
  Specifies that queries managed by the pool will count the number of patches processed by the tessellation control shader.
  `VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_EVALUATION_SHADER_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of invocations of the tessellation evaluation shader.
  `VK_QUERY_PIPELINE_STATISTIC_VERTEX_SHADER_INVOCATIONS_BIT`
  Specifies that queries managed by the pool will count the number of vertex shader invocations.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `value()`
  `static VulkanQueryPipelineStatisticFlag`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static VulkanQueryPipelineStatisticFlag[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_VERTICES_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_VERTICES_BIT
    Specifies that queries managed by the pool will count the number of vertices processed by the input assembly stage. Vertices corresponding to incomplete primitives may contribute to the count.

  - ### VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_PRIMITIVES_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_INPUT_ASSEMBLY_PRIMITIVES_BIT
    Specifies that queries managed by the pool will count the number of primitives processed by the input assembly stage. If primitive restart is enabled, restarting the primitive topology has no effect on the count. Incomplete primitives may be counted.

  - ### VK_QUERY_PIPELINE_STATISTIC_VERTEX_SHADER_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_VERTEX_SHADER_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of vertex shader invocations. This counter’s value is incremented each time a vertex shader is invoked.

  - ### VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of geometry shader invocations. This counter’s value is incremented each time a geometry shader is invoked. In the case of instanced geometry shaders, the geometry shader invocations count is incremented for each separate instanced invocation.

  - ### VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_PRIMITIVES_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_GEOMETRY_SHADER_PRIMITIVES_BIT
    Specifies that queries managed by the pool will count the number of primitives generated by geometry shader invocations. The counter’s value is incremented each time the geometry shader emits a primitive. Restarting primitive topology using the SPIR-V instructions OpEndPrimitive or OpEndStreamPrimitive has no effect on the geometry shader output primitives count.

  - ### VK_QUERY_PIPELINE_STATISTIC_CLIPPING_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_CLIPPING_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of primitives processed by the Primitive Clipping stage of the pipeline. The counter’s value is incremented each time a primitive reaches the primitive clipping stage.

  - ### VK_QUERY_PIPELINE_STATISTIC_CLIPPING_PRIMITIVES_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_CLIPPING_PRIMITIVES_BIT
    Specifies that queries managed by the pool will count the number of primitives output by the Primitive Clipping stage of the pipeline. The counter’s value is incremented each time a primitive passes the primitive clipping stage.

  - ### VK_QUERY_PIPELINE_STATISTIC_FRAGMENT_SHADER_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_FRAGMENT_SHADER_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of fragment shader invocations. The counter’s value is incremented each time the fragment shader is invoked.

  - ### VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_CONTROL_SHADER_PATCHES_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_CONTROL_SHADER_PATCHES_BIT
    Specifies that queries managed by the pool will count the number of patches processed by the tessellation control shader. The counter’s value is incremented once for each patch for which a tessellation control shader is invoked.

  - ### VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_EVALUATION_SHADER_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_TESSELLATION_EVALUATION_SHADER_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of invocations of the tessellation evaluation shader. The counter’s value is incremented each time the tessellation evaluation shader is invoked.

  - ### VK_QUERY_PIPELINE_STATISTIC_COMPUTE_SHADER_INVOCATIONS_BIT

    public static final VulkanQueryPipelineStatisticFlag VK_QUERY_PIPELINE_STATISTIC_COMPUTE_SHADER_INVOCATIONS_BIT
    Specifies that queries managed by the pool will count the number of compute shader invocations. The counter’s value is incremented every time the compute shader is invoked. Implementations may skip the execution of certain compute shader invocations or execute additional compute shader invocations for implementation-dependent reasons as long as the results of rendering otherwise remain unchanged.

- ## Method Details

  - ### values

    public static VulkanQueryPipelineStatisticFlag[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static VulkanQueryPipelineStatisticFlag valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### value

    public int value()
    Specified by:
      `value` in interface `VulkanEnumBitmaskType`
    Returns:
      The integer value of the constant